/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.Model#getDeclarations <em>Declarations</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.Model#getFixedDeclarations <em>Fixed Declarations</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.Model#getRules <em>Rules</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.Model#getElements <em>Elements</em>}</li>
 * </ul>
 *
 * @see org.xtext.example.methodname.methodName.MethodNamePackage#getModel()
 * @model
 * @generated
 */
public interface Model extends EObject
{
  /**
   * Returns the value of the '<em><b>Declarations</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.example.methodname.methodName.Declaration}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Declarations</em>' containment reference list.
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getModel_Declarations()
   * @model containment="true"
   * @generated
   */
  EList<Declaration> getDeclarations();

  /**
   * Returns the value of the '<em><b>Fixed Declarations</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.example.methodname.methodName.FixedDeclaration}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fixed Declarations</em>' containment reference list.
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getModel_FixedDeclarations()
   * @model containment="true"
   * @generated
   */
  EList<FixedDeclaration> getFixedDeclarations();

  /**
   * Returns the value of the '<em><b>Rules</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.example.methodname.methodName.Rule}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rules</em>' containment reference list.
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getModel_Rules()
   * @model containment="true"
   * @generated
   */
  EList<Rule> getRules();

  /**
   * Returns the value of the '<em><b>Elements</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.example.methodname.methodName.Case}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Elements</em>' containment reference list.
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getModel_Elements()
   * @model containment="true"
   * @generated
   */
  EList<Case> getElements();

} // Model
